<!DOCTYPE HTML>
<!-- NewPage -->
<html lang="de">
<head>
<!-- Generated by javadoc (11.0.1) on Sat Oct 05 11:12:57 CEST 2019 -->
<title>ArchiveToDataBaseConverter (dblp.datatools 2019.08.0.0 API)</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta name="dc.created" content="2019-10-05">
<link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
<link rel="stylesheet" type="text/css" href="../../../../../jquery/jquery-ui.css" title="Style">
<script type="text/javascript" src="../../../../../script.js"></script>
<script type="text/javascript" src="../../../../../jquery/jszip/dist/jszip.min.js"></script>
<script type="text/javascript" src="../../../../../jquery/jszip-utils/dist/jszip-utils.min.js"></script>
<!--[if IE]>
<script type="text/javascript" src="../../../../../jquery/jszip-utils/dist/jszip-utils-ie.min.js"></script>
<![endif]-->
<script type="text/javascript" src="../../../../../jquery/jquery-3.3.1.js"></script>
<script type="text/javascript" src="../../../../../jquery/jquery-migrate-3.0.1.js"></script>
<script type="text/javascript" src="../../../../../jquery/jquery-ui.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="ArchiveToDataBaseConverter (dblp.datatools 2019.08.0.0 API)";
        }
    }
    catch(err) {
    }
//-->
var data = {"i0":9};
var tabs = {65535:["t0","All Methods"],1:["t1","Static Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
var pathtoroot = "../../../../../";
var useModuleDirectories = true;
loadScripts(document, 'script');</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<header role="banner">
<nav role="navigation">
<div class="fixedNav">
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a id="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a id="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../index.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../../allclasses.html">All&nbsp;Classes</a></li>
</ul>
<ul class="navListSearch">
<li><label for="search">SEARCH:</label>
<input type="text" id="search" value="search" disabled="disabled">
<input type="reset" id="reset" value="reset" disabled="disabled">
</li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a id="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
</div>
<div class="navPadding">&nbsp;</div>
<script type="text/javascript"><!--
$('.navPadding').css('padding-top', $('.fixedNav').css("height"));
//-->
</script>
</nav>
</header>
<!-- ======== START OF CLASS DATA ======== -->
<main role="main">
<div class="header">
<div class="subTitle"><span class="packageLabelInType">Package</span>&nbsp;<a href="package-summary.html">bous.philipp.dblp.datatools.converter</a></div>
<h2 title="Class ArchiveToDataBaseConverter" class="title">Class ArchiveToDataBaseConverter</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li>bous.philipp.dblp.datatools.converter.ArchiveToDataBaseConverter</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt>Direct Known Subclasses:</dt>
<dd><code><a href="CommonArchivesToDatabaseConverter.html" title="class in bous.philipp.dblp.datatools.converter">CommonArchivesToDatabaseConverter</a></code></dd>
</dl>
<hr>
<pre>public class <span class="typeNameLabel">ArchiveToDataBaseConverter</span>
extends java.lang.Object</pre>
<div class="block">Has the main purpose to provide a standardized but sufficiently configurable way to convert records in
 arbitrary tar.gz xml-archives into data inside a database.
 This is achieved through the <a href="#xmlTarArchiveToDataBase(java.sql.Connection,java.lang.String,java.lang.String,java.lang.String,int,int,int,bous.philipp.dblp.datatools.converter.xmlchecks.raw.RawXmlCheck,bous.philipp.dblp.datatools.converter.heuristics.classification.ClassificationHeuristic,bous.philipp.dblp.datatools.datamodel.records.archetypes.factory.RecordFactory)"><code>xmlTarArchiveToDataBase(Connection, String, String, String, int, int, int, RawXmlCheck, ClassificationHeuristic, RecordFactory)</code></a>-method</div>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Constructor</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tr class="altColor">
<th class="colConstructorName" scope="row"><code><span class="memberNameLink"><a href="#%3Cinit%3E()">ArchiveToDataBaseConverter</a></span>()</code></th>
<td class="colLast">&nbsp;</td>
</tr>
</table>
</li>
</ul>
</section>
<!-- ========== METHOD SUMMARY =========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t1" class="tableTab"><span><a href="javascript:show(1);">Static Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colSecond" scope="col">Method</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>static void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#xmlTarArchiveToDataBase(java.sql.Connection,java.lang.String,java.lang.String,java.lang.String,int,int,int,bous.philipp.dblp.datatools.converter.xmlchecks.raw.RawXmlCheck,bous.philipp.dblp.datatools.converter.heuristics.classification.ClassificationHeuristic,bous.philipp.dblp.datatools.datamodel.records.archetypes.factory.RecordFactory)">xmlTarArchiveToDataBase</a></span>&#8203;(@NotNull java.sql.Connection&nbsp;connection,
                       @NotNull java.lang.String&nbsp;recordTableName,
                       @NotNull java.lang.String&nbsp;featureTableName,
                       @NotNull java.lang.String&nbsp;tarPath,
                       int&nbsp;batchSize,
                       int&nbsp;maxEntries,
                       int&nbsp;startIndex,
                       <a href="xmlchecks/raw/RawXmlCheck.html" title="interface in bous.philipp.dblp.datatools.converter.xmlchecks.raw">RawXmlCheck</a>&nbsp;xmlCheck,
                       @NotNull <a href="heuristics/classification/ClassificationHeuristic.html" title="interface in bous.philipp.dblp.datatools.converter.heuristics.classification">ClassificationHeuristic</a>&nbsp;classificationHeuristic,
                       @NotNull <a href="../datamodel/records/archetypes/factory/RecordFactory.html" title="interface in bous.philipp.dblp.datatools.datamodel.records.archetypes.factory">RecordFactory</a>&nbsp;recordFactory)</code></th>
<td class="colLast">
<div class="block">Processes entries of a tar.gz-file, converting them in an appropriate format to be written to a database.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a id="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></li>
</ul>
</li>
</ul>
</section>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a id="&lt;init&gt;()">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>ArchiveToDataBaseConverter</h4>
<pre>public&nbsp;ArchiveToDataBaseConverter()</pre>
</li>
</ul>
</li>
</ul>
</section>
<!-- ============ METHOD DETAIL ========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a id="xmlTarArchiveToDataBase(java.sql.Connection,java.lang.String,java.lang.String,java.lang.String,int,int,int,bous.philipp.dblp.datatools.converter.xmlchecks.raw.RawXmlCheck,bous.philipp.dblp.datatools.converter.heuristics.classification.ClassificationHeuristic,bous.philipp.dblp.datatools.datamodel.records.archetypes.factory.RecordFactory)">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>xmlTarArchiveToDataBase</h4>
<pre class="methodSignature">public static&nbsp;void&nbsp;xmlTarArchiveToDataBase&#8203;(@NotNull
                                           @NotNull java.sql.Connection&nbsp;connection,
                                           @NotNull
                                           @NotNull java.lang.String&nbsp;recordTableName,
                                           @NotNull
                                           @NotNull java.lang.String&nbsp;featureTableName,
                                           @NotNull
                                           @NotNull java.lang.String&nbsp;tarPath,
                                           int&nbsp;batchSize,
                                           int&nbsp;maxEntries,
                                           int&nbsp;startIndex,
                                           <a href="xmlchecks/raw/RawXmlCheck.html" title="interface in bous.philipp.dblp.datatools.converter.xmlchecks.raw">RawXmlCheck</a>&nbsp;xmlCheck,
                                           @NotNull
                                           @NotNull <a href="heuristics/classification/ClassificationHeuristic.html" title="interface in bous.philipp.dblp.datatools.converter.heuristics.classification">ClassificationHeuristic</a>&nbsp;classificationHeuristic,
                                           @NotNull
                                           @NotNull <a href="../datamodel/records/archetypes/factory/RecordFactory.html" title="interface in bous.philipp.dblp.datatools.datamodel.records.archetypes.factory">RecordFactory</a>&nbsp;recordFactory)</pre>
<div class="block">Processes entries of a tar.gz-file, converting them in an appropriate format to be written to a database.
 Its most prominent parameters are <a href="xmlchecks/raw/RawXmlCheck.html" title="interface in bous.philipp.dblp.datatools.converter.xmlchecks.raw"><code>RawXmlCheck</code></a>,<a href="heuristics/classification/ClassificationHeuristic.html" title="interface in bous.philipp.dblp.datatools.converter.heuristics.classification"><code>ClassificationHeuristic</code></a> and a <a href="../datamodel/records/archetypes/factory/RecordFactory.html" title="interface in bous.philipp.dblp.datatools.datamodel.records.archetypes.factory"><code>RecordFactory</code></a>.
 The first two help in determining usefulness of a record as well as a class label that is guessed without any machine learning involved (i.e. "purely" human-heuristic).
 The latter is used to instantiate the correct implementations of <a href="../datamodel/records/archetypes/RecordArchetype.html" title="interface in bous.philipp.dblp.datatools.datamodel.records.archetypes"><code>RecordArchetype</code></a> from <code>Document</code>s that are parsed from the raw xml-files.
 Ids for records and features are given incrementally upwards from the current corresponding maximum ids that are present in the database.
 Database should contain tables for records and features of following structure:
 Records:
 <ul>
     <li>`id` int(11) NOT NULL</li>
     <li>`original_id` varchar(80) DEFAULT NULL</li>
     <li>`cs_classification` tinyint(4) NOT NULL</li>
     <li>`random_id` bigint(20) DEFAULT NULL</li>
     <li>PRIMARY KEY (`id`)</li>
     <li>UNIQUE KEY `id_artificial_UNIQUE` (`id`)</li>
     <li>UNIQUE KEY `id_UNIQUE` (`original_id`)</li>
     <li>UNIQUE KEY `random_id_UNIQUE` (`random_id`)</li>
     <li></li>
 </ul>

 Features:
 <ul>
     <li>`id` int(11) NOT NULL</li>
     <li>`type` varchar(45) NOT NULL</li>
     <li>`value` text NOT NULL</li>
     <li>`record_id` int(11) DEFAULT NULL</li>
     <li>`original_position` varchar(45) DEFAULT NULL</li>
     <li>PRIMARY KEY (`id`)</li>
     <li>UNIQUE KEY `id_UNIQUE` (`id`)</li>
     <li>KEY `arxiv_features_rand_balanced_records_rand_balanced` (`record_id`)</li>
     <li>CONSTRAINT `featurs_records_key` FOREIGN KEY (`record_id`) REFERENCES `RECORD_TABLE_NAME` (`id`)</li>
 </ul></div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>connection</code> - db-connection</dd>
<dd><code>recordTableName</code> - name of the record table</dd>
<dd><code>featureTableName</code> - name of the feature table</dd>
<dd><code>tarPath</code> - path of the tar to be processed</dd>
<dd><code>batchSize</code> - how many records should be prepared before writing a batch to the db</dd>
<dd><code>maxEntries</code> - maximum number of entries to be processed, -1 for all; maxEntries is NOT the number of entries that will be put into the DB but the maximum of tars without errors that we will process</dd>
<dd><code>startIndex</code> - index defining which file in the tar should be processed first (usually this should be 0 but this would allow splitting the processing of bigger archives).</dd>
<dd><code>xmlCheck</code> - the check will pe performed as one part of the decision if a given xml-file is of interest; useful to filter corrupted documents or documents that are of a wrong type</dd>
<dd><code>classificationHeuristic</code> - its method <a href="heuristics/classification/ClassificationHeuristic.html#isUseful(bous.philipp.dblp.datatools.datamodel.RecordDocument)"><code>ClassificationHeuristic.isUseful(RecordDocument)</code></a> is the second test that determines if a document will be represented in the DB; before that, it is initially labeled by the heuristic's <a href="heuristics/classification/ClassificationHeuristic.html#guessClass(bous.philipp.dblp.datatools.datamodel.RecordDocument)"><code>ClassificationHeuristic.guessClass(RecordDocument)</code></a> method.</dd>
<dd><code>recordFactory</code> - a factory to build appropriate <a href="../datamodel/records/archetypes/RecordArchetype.html" title="interface in bous.philipp.dblp.datatools.datamodel.records.archetypes"><code>RecordArchetype</code></a>-Implementations from a <code>Document</code>, build from the given xml-files</dd>
</dl>
</li>
</ul>
</li>
</ul>
</section>
</li>
</ul>
</div>
</div>
</main>
<!-- ========= END OF CLASS DATA ========= -->
<footer role="contentinfo">
<nav role="navigation">
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a id="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a id="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../index.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../../allclasses.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a id="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</nav>
</footer>
</body>
</html>
